function ChannelManager(){
	this.contentArray = Array();
	this.sortedList = Array();
	this.hiddenList = Array();
	this.region;
	
    // ABC1
	this.icons = new Object();
	this.icons["channellogo_57"  ] = "abc1"; // ACT
	this.icons["channellogo_21"  ] = "abc1"; // Adelaide
	this.icons["channellogo_15"  ] = "abc1"; // Brisbane
	this.icons["channellogo_118" ] = "abc1"; // Central Coast
	this.icons["channellogo_39"  ] = "abc1"; // Darwin
	this.icons["channellogo_129" ] = "abc1"; // Gold Coast
	this.icons["channellogo_9"   ] = "abc1"; // Melbourne
	this.icons["channellogo_26"  ] = "abc1"; // Perth
	this.icons["channellogo_152" ] = "abc1"; // QLD Regional
	this.icons["channellogo_2"   ] = "abc1"; // Sydney
	this.icons["channellogo_46"  ] = "abc1"; // Tasmania
	this.icons["channellogo_1675"] = "abc1"; // Vic Regional
	this.icons["channellogo_61"  ] = "abc1"; // Wollongong
	
    // ABC News
	this.icons["channellogo_71"  ] = "abcnews"; // ACT
	this.icons["channellogo_76"  ] = "abcnews"; // Adelaide
	this.icons["channellogo_81"  ] = "abcnews"; // Brisbane
	this.icons["channellogo_147" ] = "abcnews"; // Central Coast
	this.icons["channellogo_86"  ] = "abcnews"; // Darwin
	this.icons["channellogo_142" ] = "abcnews"; // Gold Coast
	this.icons["channellogo_90"  ] = "abcnews"; // Melbourne
	this.icons["channellogo_95"  ] = "abcnews"; // Perth
	this.icons["channellogo_164" ] = "abcnews"; // QLD Regional
	this.icons["channellogo_100" ] = "abcnews"; // Sydney
	this.icons["channellogo_105" ] = "abcnews"; // Tasmania
	this.icons["channellogo_1680"] = "abcnews"; // Vic Regional
	this.icons["channellogo_110" ] = "abcnews"; // Wollongong
	
    // ABC2
	this.icons["channellogo_58"  ] = "abc2"; // ACT
	this.icons["channellogo_34"  ] = "abc2"; // Adelaide
	this.icons["channellogo_35"  ] = "abc2"; // Brisbane
	this.icons["channellogo_119" ] = "abc2"; // Central Coast
	this.icons["channellogo_40"  ] = "abc2"; // Darwin
	this.icons["channellogo_139" ] = "abc2"; // Gold Coast
	this.icons["channellogo_36"  ] = "abc2"; // Melbourne
	this.icons["channellogo_37"  ] = "abc2"; // Perth
	this.icons["channellogo_153" ] = "abc2"; // QLD Regional
	this.icons["channellogo_38"  ] = "abc2"; // Sydney
	this.icons["channellogo_47"  ] = "abc2"; // Tasmania
	this.icons["channellogo_1676"] = "abc2"; // Vic Regional
	this.icons["channellogo_62"  ] = "abc2"; // Wollongong

    // ABC3
	this.icons["channellogo_2411"] = "abc3"; // ACT
	this.icons["channellogo_2412"] = "abc3"; // Adelaide
	this.icons["channellogo_2413"] = "abc3"; // Brisbane
	this.icons["channellogo_2414"] = "abc3"; // Central Coast
	this.icons["channellogo_2415"] = "abc3"; // Darwin
	this.icons["channellogo_2416"] = "abc3"; // Gold Coast
	this.icons["channellogo_2417"] = "abc3"; // Melbourne
	this.icons["channellogo_2418"] = "abc3"; // Perth
	this.icons["channellogo_2419"] = "abc3"; // QLD Regional
	this.icons["channellogo_2410"] = "abc3"; // Sydney
	this.icons["channellogo_2420"] = "abc3"; // Tasmania
	this.icons["channellogo_2421"] = "abc3"; // Vic Regional
	this.icons["channellogo_2422"] = "abc3"; // Wollongong
	
    // SBS
	this.icons["channellogo_59"  ] = "sbs"; // ACT
	this.icons["channellogo_22"  ] = "sbs"; // Adelaide
	this.icons["channellogo_16"  ] = "sbs"; // Brisbane
	this.icons["channellogo_120" ] = "sbs"; // Central Coast
	this.icons["channellogo_41"  ] = "sbs"; // Darwin
	this.icons["channellogo_131" ] = "sbs"; // Gold Coast
	this.icons["channellogo_10"  ] = "sbs"; // Melbourne
	this.icons["channellogo_27"  ] = "sbs"; // Perth
	this.icons["channellogo_154" ] = "sbs"; // QLD Regional
	this.icons["channellogo_1"   ] = "sbs"; // Sydney
	this.icons["channellogo_51"  ] = "sbs"; // Tasmania
	this.icons["channellogo_1677"] = "sbs"; // Vic Regional
	this.icons["channellogo_63"  ] = "sbs"; // Wollongong
	
    // SBS HD
	this.icons["channellogo_73"  ] = "sbshd"; // ACT
	this.icons["channellogo_78"  ] = "sbshd"; // Adelaide
	this.icons["channellogo_83"  ] = "sbshd"; // Brisbane
	this.icons["channellogo_149" ] = "sbshd"; // Central Coast
	this.icons["channellogo_88"  ] = "sbshd"; // Darwin
	this.icons["channellogo_144" ] = "sbshd"; // Gold Coast
	this.icons["channellogo_92"  ] = "sbshd"; // Melbourne
	this.icons["channellogo_97"  ] = "sbshd"; // Perth
	this.icons["channellogo_168" ] = "sbshd"; // QLD Regional
	this.icons["channellogo_102" ] = "sbshd"; // Sydney
	this.icons["channellogo_106" ] = "sbshd"; // Tasmania
	this.icons["channellogo_1678"] = "sbshd"; // Vic Regional
	this.icons["channellogo_113" ] = "sbshd"; // Wollongong
	
    // SBS 2
	this.icons["channellogo_60"  ] = "sbs2"; // ACT
	this.icons["channellogo_30"  ] = "sbs2"; // Adelaide
	this.icons["channellogo_31"  ] = "sbs2"; // Brisbane
	this.icons["channellogo_123" ] = "sbs2"; // Central Coast
	this.icons["channellogo_42"  ] = "sbs2"; // Darwin
	this.icons["channellogo_138" ] = "sbs2"; // Gold Coast
	this.icons["channellogo_32"  ] = "sbs2"; // Melbourne
	this.icons["channellogo_33"  ] = "sbs2"; // Perth
	this.icons["channellogo_155" ] = "sbs2"; // QLD Regional
	this.icons["channellogo_29"  ] = "sbs2"; // Sydney
	this.icons["channellogo_52"  ] = "sbs2"; // Tasmania
	this.icons["channellogo_1679"] = "sbs2"; // Vic Regional
	this.icons["channellogo_64"  ] = "sbs2"; // Wollongong
	
    // SEVEN
	this.icons["channellogo_18"  ] = "seven"; // Adelaide
	this.icons["channellogo_12"  ] = "seven"; // Brisbane
	this.icons["channellogo_124" ] = "seven"; // Central Coast
	this.icons["channellogo_134" ] = "seven"; // Gold Coast
	this.icons["channellogo_6"   ] = "seven"; // Melbourne
	this.icons["channellogo_23"  ] = "seven"; // Perth
	this.icons["channellogo_156" ] = "seven"; // QLD Regional
	this.icons["channellogo_3"   ] = "seven"; // Sydney
	this.icons["channellogo_1689"] = "seven"; // Vic Regional
	this.icons["channellogo_69"  ] = "seven"; // Wollonging
	
    // 7mate
	this.icons["channellogo_72"  ] = "7mate"; // ACT
	this.icons["channellogo_79"  ] = "7mate"; // Adelaide
	this.icons["channellogo_84"  ] = "7mate"; // Brisbane
	this.icons["channellogo_150" ] = "7mate"; // Central Coast
	this.icons["channellogo_175" ] = "7mate"; // Central Coast (on Prime)
	this.icons["channellogo_89"  ] = "7mate"; // Darwin
	this.icons["channellogo_145" ] = "7mate"; // Gold Coast
	this.icons["channellogo_178" ] = "7mate"; // Gold Coast (regional)
	this.icons["channellogo_93"  ] = "7mate"; // Melbourne
	this.icons["channellogo_98"  ] = "7mate"; // Perth
	this.icons["channellogo_167" ] = "7mate"; // QLD Regional (regional?)
	this.icons["channellogo_169" ] = "7mate"; // QLD Regional
	this.icons["channellogo_170" ] = "7mate"; // QLD Regional
	this.icons["channellogo_171" ] = "7mate"; // QLD Regional
	this.icons["channellogo_103" ] = "7mate"; // Sydney
	this.icons["channellogo_107" ] = "7mate"; // Tasmania
	this.icons["channellogo_1690"] = "7mate"; // Vic Regional
	this.icons["channellogo_1682"] = "7mate"; // Vic Regional (Regional?)
	this.icons["channellogo_114" ] = "7mate"; // Wollongong
	this.icons["channellogo_112" ] = "7mate"; // Wollongong (Regional?)
	
	// 7TWO
	this.icons["channellogo_2425"] = "7two"; // ACT
	this.icons["channellogo_2401"] = "7two"; // Adelaide
	this.icons["channellogo_2402"] = "7two"; // Brisbane
	this.icons["channellogo_2403"] = "7two"; // Central Coast
	this.icons["channellogo_2424"] = "7two"; // Darwin
	this.icons["channellogo_2404"] = "7two"; // Gold Coast
	this.icons["channellogo_2405"] = "7two"; // Melbourne
	this.icons["channellogo_2406"] = "7two"; // Perth
	this.icons["channellogo_2407"] = "7two"; // QLD Regional
	this.icons["channellogo_2397"] = "7two"; // Sydney
	this.icons["channellogo_2423"] = "7two"; // Tasmania
	this.icons["channellogo_2408"] = "7two"; // Vic Regional
	this.icons["channellogo_2409"] = "7two"; // Wollongong
	
	// 7TWO on Prime
	this.icons["channellogo_2446"] = "7twoprime"; // ACT
	this.icons["channellogo_2447"] = "7twoprime"; // Central Coast
	this.icons["channellogo_2448"] = "7twoprime"; // Gold Coast
	this.icons["channellogo_2449"] = "7twoprime"; // Vic Regional
	this.icons["channellogo_2450"] = "7twoprime"; // Wollongong

    // SEVEN QLD
	this.icons["channellogo_159" ] = "sevencentral";    // QLD Regional
	this.icons["channellogo_162" ] = "sevenqld";        // QLD Regional
	
    // NINE
	this.icons["channellogo_19"  ] = "nine"; // Adelaide
	this.icons["channellogo_13"  ] = "nine"; // Brisbane
	this.icons["channellogo_122" ] = "nine"; // Central Coast
	this.icons["channellogo_44"  ] = "nine"; // Darwin
	this.icons["channellogo_133" ] = "nine"; // Gold Coast
	this.icons["channellogo_7"   ] = "nine"; // Melbourne
	this.icons["channellogo_24"  ] = "nine"; // Perth
	this.icons["channellogo_157" ] = "nine"; // QLD Regional
	this.icons["channellogo_4"   ] = "nine"; // Sydney
	this.icons["channellogo_1687"] = "nine"; // Vic Regional
	this.icons["channellogo_68"  ] = "nine"; // Wollongong
	
    // GEM
	this.icons["channellogo_75"  ] = "gem"; // ACT (WIN)
	this.icons["channellogo_77"  ] = "gem"; // Adelaide
	this.icons["channellogo_82"  ] = "gem"; // Brisbane
	this.icons["channellogo_148" ] = "gem"; // Central Coast
	this.icons["channellogo_174" ] = "gem"; // Central Coast (Regional)
	this.icons["channellogo_87"  ] = "gem"; // Darwin
	this.icons["channellogo_143" ] = "gem"; // Gold Coast
	this.icons["channellogo_177" ] = "gem"; // Gold Coast (Regional)
	this.icons["channellogo_91"  ] = "gem"; // Melbourne
	this.icons["channellogo_96"  ] = "gem"; // Perth
	this.icons["channellogo_166" ] = "gem"; // QLD Regional
	this.icons["channellogo_173" ] = "gem"; // QLD Regional (Win)
	this.icons["channellogo_101" ] = "gem"; // Sydney
	this.icons["channellogo_109" ] = "gem"; // Tasmania (WIN)
	this.icons["channellogo_1688"] = "gem"; // Vic Regional
	this.icons["channellogo_1684"] = "gem"; // Vic Regional (WIN)
	this.icons["channellogo_111" ] = "gem"; // Wollongong
	this.icons["channellogo_117" ] = "gem"; // Wollongong (WIN)

    // TEN
	this.icons["channellogo_20"  ] = "ten"; // Adelaide
	this.icons["channellogo_14"  ] = "ten"; // Brisbane
	this.icons["channellogo_125" ] = "ten"; // Central Coast
	this.icons["channellogo_141" ] = "ten"; // Gold Coast
	this.icons["channellogo_8"   ] = "ten"; // Melbourne
	this.icons["channellogo_25"  ] = "ten"; // Perth
	this.icons["channellogo_158" ] = "ten"; // QLD Regional
	this.icons["channellogo_5"   ] = "ten"; // Sydney
	this.icons["channellogo_1691"] = "ten"; // Vic Regional
	this.icons["channellogo_70"  ] = "ten"; // Wollongong
	
    // Eleven
	this.icons["channellogo_2459"] = "eleven"; // ACT
	this.icons["channellogo_1693"] = "eleven"; // Adelaide
	this.icons["channellogo_1694"] = "eleven"; // Brisbane
	this.icons["channellogo_1695"] = "eleven"; // Central Coast
	this.icons["channellogo_1696"] = "eleven"; // Gold Coast
	this.icons["channellogo_1697"] = "eleven"; // Melbourne
	this.icons["channellogo_1698"] = "eleven"; // Perth
	this.icons["channellogo_1699"] = "eleven"; // QLD Regional
	this.icons["channellogo_1700"] = "eleven"; // Sydney
	this.icons["channellogo_2460"] = "eleven"; // Tasmania
	this.icons["channellogo_1701"] = "eleven"; // Vic Regional
	this.icons["channellogo_1702"] = "eleven"; // Wollongong   

    // ONE HD
	this.icons["channellogo_80"  ] = "onehd"; // Adelaide
	this.icons["channellogo_85"  ] = "onehd"; // Brisbane
	this.icons["channellogo_151" ] = "onehd"; // Central Coast
	this.icons["channellogo_146" ] = "onehd"; // Gold Coast
	this.icons["channellogo_94"  ] = "onehd"; // Melbourne
	this.icons["channellogo_99"  ] = "onehd"; // Perth
	this.icons["channellogo_172" ] = "onehd"; // QLD Regional
	this.icons["channellogo_104" ] = "onehd"; // Sydney
	this.icons["channellogo_1692"] = "onehd"; // Vic Regional
	this.icons["channellogo_116" ] = "onehd"; // Wollongong
	
    // PRIME
	this.icons["channellogo_56"  ] = "prime7"; // ACT
	this.icons["channellogo_127" ] = "prime7"; // Central Coast
	this.icons["channellogo_137" ] = "prime7"; // Gold Coast
	this.icons["channellogo_1681"] = "prime7"; // Vic Regional
	this.icons["channellogo_65"  ] = "prime7"; // Wollongong
	
    // SC10
	this.icons["channellogo_55"  ] = "sc10"; // ACT
	this.icons["channellogo_128" ] = "sc10"; // Central Coast
	this.icons["channellogo_45"  ] = "sc";   // Darwin
	this.icons["channellogo_140" ] = "sc10"; // Gold Coast
	this.icons["channellogo_163" ] = "sc10"; // QLD Regional
	this.icons["channellogo_50"  ] = "sc";   // Tasmania
	this.icons["channellogo_1685"] = "sc10"; // Vic Regional
	this.icons["channellogo_67"  ] = "sc10"; // Wollongong
	
    // SC10 HD
	this.icons["channellogo_74"  ] = "sc10hd"; // ACT
	this.icons["channellogo_176" ] = "sc10hd"; // Central Coast
	this.icons["channellogo_179" ] = "sc10hd"; // Gold Coast
	this.icons["channellogo_1686"] = "sc10hd"; // Vic Regional
	this.icons["channellogo_115" ] = "sc10hd"; // Wollongong
	
    // WIN
	this.icons["channellogo_54"  ] = "win"; // ACT
	this.icons["channellogo_161" ] = "win"; // QLD Regional
	this.icons["channellogo_48"  ] = "win"; // Tasmania
	this.icons["channellogo_1683"] = "win"; // Vic Regional
	this.icons["channellogo_66"  ] = "win"; // Wollongong
	
    // NBN
	this.icons["channellogo_126" ] = "nbn"; // Central Coast
	this.icons["channellogo_135" ] = "nbn"; // Gold Coast
	
    // Imparja
	this.icons["channellogo_160" ] = "imparja"; // QLD Regional
	
    // Imparja HD
	this.icons["channellogo_165" ] = "imparjahd"; // QLD Regional
	
    // Tasmania Digital Television
	this.icons["channellogo_49"  ] = "tdt"; // Tasmania
	
    // Tasmania Digital Television HD
	this.icons["channellogo_108" ] = "tdthd"; // Tasmania

    // Darwin Digital Television
	this.icons["channellogo_180" ] = "ddt"; // Darwin

    // Darwin Digital Television HD
	this.icons["channellogo_181" ] = "ddthd"; // Darwin
	
    // GWN
	this.icons["channellogo_182" ] = "gwn7"; // Perth
    
    
    // 31
	this.icons["channellogo_2458"] = "31"; // Adelaide
	this.icons["channellogo_17"  ] = "31"; // Brisbane
	this.icons["channellogo_11"  ] = "31"; // Melbourne
	this.icons["channellogo_2457"] = "31"; // Vic Regional

	// TVS
	this.icons["channellogo_2456"] = "tvs"; // Central Coast
	this.icons["channellogo_2453"] = "tvs"; // Sydney
	this.icons["channellogo_2455"] = "tvs"; // Wollongong

    // WTV
	this.icons["channellogo_28"  ] = "wtv"; // Perth

    // GO!
	this.icons["channellogo_2384"  ] = "go"; // ACT
	this.icons["channellogo_2385"  ] = "go"; // Adelaide
	this.icons["channellogo_2386"  ] = "go"; // Brisbane
	this.icons["channellogo_2387"  ] = "go"; // Central Coast
	this.icons["channellogo_2388"  ] = "go"; // Darwin
	this.icons["channellogo_2389"  ] = "go"; // Gold Coast
	this.icons["channellogo_2390"  ] = "go"; // Melbourne
	this.icons["channellogo_2391"  ] = "go"; // Perth
	this.icons["channellogo_2392"  ] = "go"; // QLD Regional
	this.icons["channellogo_2393"  ] = "go"; // Sydney
	this.icons["channellogo_2394"  ] = "go"; // Tasmania
	this.icons["channellogo_2395"  ] = "go"; // Vic Regional
	this.icons["channellogo_2396"  ] = "go"; // Wollongong
	
    // 3D Test
	this.icons["channellogo_2439"  ] = "3dtest"; // Adelaide
	this.icons["channellogo_2440"  ] = "3dtest"; // Brisbane
	this.icons["channellogo_2442"  ] = "3dtest"; // Central Coast
	this.icons["channellogo_2441"  ] = "3dtest"; // Melbourne
	this.icons["channellogo_2438"  ] = "3dtest"; // Perth
	this.icons["channellogo_2437"  ] = "3dtest"; // Sydney
	this.icons["channellogo_2443"  ] = "3dtest"; // Wollongong
}

ChannelManager.prototype.iconForChannel = function(channel){
	var icon;
	if(this.icons["channellogo_" + channel])
		icon =  this.icons["channellogo_" + channel];
	if(icon)
		return "images/channels/" + icon + ".png";
	return "";
}

ChannelManager.prototype.nameForID = function(id){
	for(i=0;i<this.contentArray.length;i++){
		if(this.contentArray[i]['id'] == id)
			return this.contentArray[i]['name'];
	}
	return "";
}

ChannelManager.prototype.isHidden = function(id){
	for(i=0;i<this.hiddenList.length;i++){
		if(this.hiddenList[i] == id)
			return true;
	}
	return false;
}

ChannelManager.prototype.setHidden = function(id, isHidden){
	if(isHidden){
		this.hiddenList.push(id);
		savePref(this.hiddenList.toJSON(), "channelListHidden");
	} else {
		for(i=0;i<this.hiddenList.length;i++){
			if(this.hiddenList[i] == id){
				this.hiddenList.splice(i, 1);
			}
		}
		savePref(this.hiddenList.toJSON(), "channelListHidden");
	}
	epg.updateChannelVisibilty();
}

ChannelManager.prototype.shortNameForID = function(id){
	for(i=0;i<this.contentArray.length;i++){
		if(this.contentArray[i]['id'] == id)
			return this.contentArray[i]['short_name'];
	}
	return "";
}

ChannelManager.prototype.downloaderCallback = function(json){
//    DEBUGLOG("ChannelManager.js[338]: json: " + json);
	var tempArray = eval(json);
	if(!tempArray)
		return;
		
	this.contentArray.length = 0;
	
	channelHeader = tempArray.shift();
    DEBUGLOG("channelManager.js[330]: return_code: " + channelHeader["return_code"]);
    if(channelHeader && channelHeader["return_code"] == "10") {
        ath.expire();
        return;
    }
    else if(channelHeader && channelHeader["return_code"] == "55") {
        ath.subExpired();
        return;
    }
    
	this.contentArray = this.contentArray.concat(tempArray);
	
	if(this.contentArray.length == 0)
		return;

	if(loadPref("region"))
		this.region = loadPref("region");

	if(this.sortedList.length == 0 && loadPref("channelListSortOrder"))
		this.sortedList = eval(loadPref("channelListSortOrder")); // Read from prefs

	if(this.hiddenList.length == 0 && loadPref("channelListHidden"))
		this.hiddenList = eval(loadPref("channelListHidden")); // Read from prefs
	/**
	 * Remove any channels in the hidden list that aren't in the current channel lineup
	 */
	//purgeChannelHiddenList();

	/**
	 * After loading prefs, if the sort order is empty or the channelArray length
	 * and the sortOrderArray are not equal (region has changed) then we reset the
	 * sort order and hidden arrays; The sort order will be rebuilt.
	 */
	if(this.sortedList.length == 0 || this.sortedList.length != this.contentArray.length || this.region != this.contentArray[0]['region']) 
	{
		this.region = this.contentArray[0]["region"];
		this.sortedList = Array(); 
		this.hiddenList = Array();
		this.contentArray = this.contentArray.sort(sortChannelsByNetworkAndLCN);
		for(i=0;i<this.contentArray.length;i++)
		{
			this.sortedList.push(this.contentArray[i]['id']);
		}
		savePref(this.sortedList.toJSON(), "channelListSortOrder");
		savePref(this.contentArray[0]['region'], "region");
	}

	channelListUpdated();
}

function sortChannelsByNetworkAndLCN(a, b) {
	if(a['network'] == b['network']) {
		if(a['lcn'] < b['lcn']) return -1;
		if(a['lcn'] == b['lcn']) return 0;
		if(a['lcn'] > b['lcn']) return 1;
	} else {
		if(a['network'] < b['network']) return -1;
		if(a['network'] > b['network']) return 1;
	}
}

ChannelManager.prototype.setSortOrder = function(order){
	this.sortedList.length = 0;
	this.sortedList = this.sortedList.concat(order);
	savePref(this.sortedList.toJSON(), "channelListSortOrder");
	channelOrderUpdater();
}